#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include "db.h"

/* allocate memory for record */
/* static RECORD * newRec( int n )
 * {
 *  int * dList;
 *  RECORD * rec;
 * 
 *  dList = ( int * ) malloc ( n*sizeof( int ) );
 *  rec = ( RECORD * )malloc( sizeof( RECORD ) );
 *  rec->itemList = dList;
 * 
 *  return rec;
 * }
 */

/* allocate memory for database */
static DBASE * newDb( int recs, int flds )
{
  int *rTable, *idList;
  DBASE * db;

  db = ( DBASE * ) malloc( sizeof ( DBASE ) );
  rTable= (int *) malloc ( recs*flds*sizeof( int ) );
  idList = ( int * ) malloc( recs*sizeof( int ) );
  db->table = rTable;
  db->transId=idList;
  db->numOfRecs=recs;
  db->numOfItems=flds;
  return db ;
}

/* insert a record in database at specified offset */
/* static void insertRecAt( DBASE * db, int offset, RECORD * rec )
 * {
 *  RECORD ** p;
 *
 * p=db->table+offset;
 * *p=rec;
 *}
 */

/* remove from memory */
/* void delRec( RECORD * p )
 * {
 *  free(p->itemList);
 *  free(p);
 * }
 */

void delDb( DBASE * db )
{
  free( db->table );
  free( db->transId );
}

/* read from file */
DBASE * readFrom( FILE * dbFile )
{
  DBASE * db;
  FILE * fp;
  int rowNum=0, colNum=0, i=0, j=0;
  char line[1024];
  char *cp , *cp0;
  register int c;
  int idx;

  /* determine the length and the width of a table */
  fp=dbFile;

  /* assumes the number of lines in file is the number of records */
  c = getc(fp);
  while ( c !=EOF ) {
    rowNum = ( c=='\n'? rowNum+1 : rowNum );
    c=getc( fp );
  }

  /* finding out the column number */
  rewind( fp );
  do {
    c=getc( fp );
    if( isspace( c ) ) colNum++;
  } while ( c!='\n'&&c!=NULL );

  colNum--;
  /* because the first column is transaction Id */

  db = newDb( rowNum,colNum );

  /* put data to the structure table */
  rewind( fp );
  idx=0;

  for ( i=0; i<rowNum; i++ ) {
    cp=fgets( line, 1024, fp );
    cp0=strtok( cp," " );
    db->transId[i]= atoi( cp0 );

    for ( j=0; j<colNum; j++ ) {
      cp0=strtok( NULL," " );
      (db->table)[ idx ]=atoi( cp0 );
      idx++;
    }
  }
  return db;
}

void report( DBASE * db )
{
  int i, j, idx=0;

  for (i=0; i<db->numOfRecs; i++ ) {
    printf("\n");
    printf("trans ID: %d\t",( db->transId[ i ] ) );
    for (j=0; j<db->numOfItems; j++ ) {
      printf("%d\t", ( db->table )[ idx ] );
      idx++;
    }
  }

  printf("\n");
}

/*
 * find out the sum of `recNum' records in a
 * specified field in a table
 * can also be used in summarize a section of
 * a table
 */ 
int sumOfField( int * table, int fieldId, int numOfFlds, int recNum )
{
  int sum=0;
  int idx;

  idx=fieldId;
  while ( recNum-->0 ) {
    sum+=table [ idx ];
    idx+=numOfFlds; /* move to next record, same field */
  }
  return sum;
}
